#include <string>
#include <sstream>
#include "windows.h"
#include "HeXHubSDK.h"
#include "sysinfo.h"

CRITICAL_SECTION Lock;
Sysinfo sys;
long trigId, hlpId;

void HEXHUBAPI onSystemInfoCmd(DWORD dwCommandId, DWORD userId, LPVOID rights, LPVOID commandParameters, BOOL isPM);

const char * HEXHUBAPI InitPlugin(lpfnGetFunction HexGetFunction) {
	//HexHubFunctions functions;
	HexHub Hex;
	
	if (Hex.Initialize(HexGetFunction) == false) return 0;

	if ((trigId = HexHub::Core::RegisterCommand("systeminfo", onSystemInfoCmd)) == -1) return 0;
	
	if ((hlpId = HexHub::Core::RegisterHelpString("EN", "!systeminfo\t\t\t-\tShows Core System Information", 0)) == -1) {
		HexHub::Core::UnregisterCommand(trigId);
		return 0;
	}

	InitializeCriticalSection(&Lock);

	return "System Information Plugin 0.3 by The Architect";
}

void HEXHUBAPI UnloadPlugin(void) {
	DeleteCriticalSection(&Lock);
	HexHub::Core::UnregisterCommand(trigId);
	HexHub::Core::UnregisterHelpString(hlpId);
}

const char * HEXHUBAPI GetAboutText(void) {
	return "Mikhail Polenin (The Architect) 2007-2008";
}

void HEXHUBAPI onSystemInfoCmd(DWORD dwCommandId,DWORD userId,LPVOID rights,LPVOID commandParameters,BOOL isPM)
{
	if(dwCommandId != trigId) return;
	
	std::string inf;

	EnterCriticalSection(&Lock);
	inf = sys.GetSysinfo();
	LeaveCriticalSection(&Lock);

	HexHub::Data::SendTo(userId, inf.c_str(), (int)inf.length());
}